﻿version
6.50
0
DrawingForm
4
drawer:Drawer
DrawingFormLib:FormLib
pen1:Pen
dr:ImageClass
Sub designer
addform(DrawingForm,"Drawing","",255,255,255)@
addbutton(drawingform,btnWhite,114,215,25,25,"",255,255,255,0,0,0,True,True,9)@
addnum(drawingform,DRNum1,180,215,45,1,100,255,255,255,True,True)@
addlabel(drawingform,WidthLabel,140,215,40,20,"Width",255,255,255,0,0,0,True,True,9)@
addbutton(drawingform,btnGreen,87,215,25,25,"",0,255,0,0,0,0,True,True,9)@
addbutton(drawingform,btnRed,60,215,25,25,"",255,0,0,0,0,0,True,True,9)@
addbutton(drawingform,btnBlue,33,215,25,25,"",0,0,255,0,0,0,True,True,9)@
addbutton(drawingform,btnBlack,6,215,25,25,"",0,0,0,0,0,0,True,True,9)@
addtextbox(drawingform,DrawNameTextBox,15,245,160,22,"",255,255,255,0,0,0,True,True,False,9)@
addsavedialog(drawingform,SaveDialog1,95,95,Drawings|*.gif)@
addbutton(drawingform,DRSaveButton,180,245,45,23,"Save",212,208,200,0,0,0,True,True,9)@
End Sub
@EndOfDesignText@
Sub Globals
	'Declare the global variables here.
 x1 = 0 	
 x2 = 0 
 y1 = 0 
 y2 = 0
	Dim Type(x,y) points(0) ' Drawing
 DrawerBottom=DrawingForm.Height-84
 DrawerRight=DrawingForm.Height-60
 bMouse = False
 penColour = cBlack
 penWidth=1
	
	'drawer.New1("DrawingForm",false)
 dr.New1
	DrawingFormLib.New1("DrawingForm",B4PObject(1))
End Sub
Sub DrawingForm_MouseDown (x,y)
 bMouse = True
 'frmDraw.ForeLayer = True
 x1 = X	
 y1 = Y 
End Sub
Sub DrawingForm_MouseMove (x,y)	
 If bMouse Then		
  x2 = X	
  y2 = Y			
  pen1.New1 (penColour)
  If drawingform.Width > drawingform.Height Then ' Landscape
   If x2 < DrawerRight Then
    drawthickline
    drawer.Refresh(x1, y1, x2, y2)
   End If
  Else
   If y2 < DrawerBottom Then
    drawthickline
    drawer.Refresh(x1, y1, x2, y2)
   End If
  End If
  x1 = x2	
  y1 = y2				
 End If 

End Sub
Sub DrawingForm_MouseUp (x,y)
 bMouse = False
 'frmDraw.ForeLayer = Falsee
End Sub
Sub DRCancelButton_Click
 DrawingForm.Close
End Sub
Sub DRSaveButton_Click
 dr.Image = dr.CopyImage(DrawingForm.Image,0,0,238,200)	'Copy image off form, trimming the white space off
              'the bottom of the image and the black line that
              'that appears down the side
 dr.SaveImageGIF(DrawingForm.Image,Main.wikiDir & DrawNameTextBox.Text & ".gif")
 DrawingForm.Close
End Sub
Sub DrawingForm_Show
 DrawingForm.Image=""
 drawer.New1("DrawingForm",False)
 DrawNameTextBox.Text= "Img" & DateYear(Now) & DateMonth(Now) & DateDay(Now) & TimeHour(Now) & TimeMinute(Now)
End Sub
Sub DrawingForm_Close
 textPos = Main.TextEdit.SelectionStart
 Main.TextEdit.Text  = StrInsert(Main.TextEdit.Text,textPos,"[$" & DrawNameTextBox.Text & ".gif$]")
 Main.TextEdit.SelectionStart = textPos + 1
 Main.TextEdit.ScrollToCaret
End Sub
Sub btnBlue_click
 PenColour = cBlue
End Sub
Sub btnBlack_click
 PenColour = cBlack
End Sub
Sub btnRed_click
 PenColour = cRed
End Sub
Sub btnGreen_click
 PenColour = cGreen
End Sub
Sub btnWhite_click
 PenColour = cWhite
End Sub
Sub DrawThickLine
 Form="DrawingForm"
    l = ATan((y2-y1)/(x2-x1+0.01))
    dx = penWidth/2 * Sin(l)
    dy = penWidth/2 * Cos(l)
    points() = Array((x1 + dx,y1 - dy),(x2 + dx,y2 - dy),(x2 - dx,y2 + dy),(x1 - dx,y1 + dy))
    Control(Form,Form).Polygon(points(),0,4,Pencolour,f)
    Control(Form,Form).Circle(x1,y1,penWidth/2,Pencolour,f)

End Sub
Sub DRNum1_ValueChanged
 If DRNum1.Value > 0 Then
  penWidth = DRNum1.Value
 End If
End Sub
Sub DrawingFormLib_Resize
 If DrawingForm.Width > DrawingForm.Height  Then' landscape
  DrawerRight=Drawingform.Width-60
  btnBlack.Top=5
  btnBlack.Left=drawingform.Width-54
  btnBlue.Top=5
  btnBlue.Left=drawingform.Width-27
  btnRed.Top=32
  btnRed.Left=drawingform.Width-54
  btnGreen.Top=32
  btnGreen.Left=drawingform.Width-27
  btnWhite.Top=59
  btnWhite.Left=drawingform.Width-54
  widthlabel.Top=86
  widthlabel.Left=drawingform.Width-54
  DRNum1.Top=108
  DRNum1.Left=drawingform.Width-54
  DrawNameTextBox.Top=133
  DrawNameTextBox.Left=drawingform.Width-54
  DrawNameTextBox.Width=50
  DRSaveButton.Top=160
  DRSaveButton.Left=drawingform.Width-54
 Else
  DrawerBottom=drawingform.Height-84
  btnBlack.Top=drawingform.Height-53
  btnBlack.Left=6
  btnBlue.Top=drawingform.Height-53
  btnBlue.Left=33
  btnRed.Top=drawingform.Height-53
  btnRed.Left=60
  btnGreen.Top=drawingform.Height-53
  btnGreen.Left=87
  btnWhite.Top=drawingform.Height-53
  btnWhite.Left=114
  widthlabel.Top=drawingform.Height-53
  widthlabel.Left=140
  DRNum1.Top=drawingform.Height-53
  DRNum1.Left=180
  DrawNameTextBox.Top=drawingform.Height-26
  DrawNameTextBox.Left=15
  DrawNameTextBox.Width=160
  DRSaveButton.Top=drawingform.Height-26
  DRSaveButton.Left=180
 End If
End Sub